#ifndef _GPURFPC_H_
#define _GPURFPC_H_

#include "BaseConstVariable.h"
#include "GPUTool.cuh"
#include <cuda_runtime.h>
#include <device_launch_parameters.h>
#include <cublas_v2.h>
#include <cuComplex.h>

#define RFPCPIDIVLIGHT -4*PI/(LIGHTSPEED/1e9)

 
extern "C" struct  CUDASigmaParam {
	double p1;
	double p2;
	double p3;
	double p4;
	double p5;
	double p6;
};



extern __host__ __device__ double GPU_getSigma0dB(
	const double p1, const double p2, const  double p3, const  double p4, const  double p5, const  double p6,
	double theta);

extern __host__ __device__ double GPU_getSigma0dB(CUDASigmaParam param, double theta);

extern __host__ __device__ CUDAVectorEllipsoidal GPU_SatelliteAntDirectNormal(
	double RstX, double RstY, double RstZ,
	double  AntXaxisX, double  AntXaxisY, double  AntXaxisZ,
	double  AntYaxisX, double  AntYaxisY, double  AntYaxisZ,
	double  AntZaxisX, double  AntZaxisY, double  AntZaxisZ,
	double  AntDirectX, double  AntDirectY, double  AntDirectZ
);

extern __host__ __device__ double GPU_BillerInterpAntPattern(double* antpattern,
	double starttheta, double startphi, double dtheta, double dphi,
	long thetapoints, long phipoints,
	double searththeta, double searchphi);



extern "C" void CUDA_RFPC_MainProcess(
	// 
	double* antX, double* antY, double* antZ, // 
	double* antXaxisX, double* antXaxisY, double* antXaxisZ, // ϵX
	double* antYaxisX, double* antYaxisY, double* antYaxisZ,// ϵY
	double* antZaxisX, double* antZaxisY, double* antZaxisZ,// ϵZ
	double* antDirectX, double* antDirectY, double* antDirectZ,// ߵָ
	long PRFCount, long FreqNum,   // Ƶ
	float f0, float dfreq,// ʼƵʣֹƵ
	double Pt,// 
	double refPhaseRange,
	// ߷ͼ
	double* TransAntpattern, double Transtarttheta, double Transstartphi, double Transdtheta, double Transdphi, int Transthetapoints, int Transphipoints, // ߷ͼ
	double* ReceiveAntpattern, double Receivestarttheta, double Receivestartphi, double Receivedtheta, double Receivedphi, int Receivethetapoints, int Receivephipoints,//߷ͼ
	double maxTransAntPatternValue,double maxReceiveAntPatternValue,
	double NearR, double FarR, // 뷶Χ


	// 
	double* targetX, double* targetY, double* targetZ, long* demCls, long TargetPixelNumber, // ꡢرͣ
	double* demSlopeX, double* demSlopeY, double* demSlopeZ, // ر¶ʸ
	CUDASigmaParam* sigma0Paramslist, long sigmaparamslistlen,// ֵͼ
 
	float* out_echoReal, float* out_echoImag,// ز

	float* d_temp_R, float* d_temp_amp
);











#endif



 